/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.util;

import fr.cenra.rhomeo.core.RhomeoCore;
import java.sql.Timestamp;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalTime;
import java.time.Month;
import java.time.ZoneId;
import java.time.ZoneOffset;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.util.logging.Level;
import org.apache.sis.internal.converter.SystemRegistry;
import org.apache.sis.util.ObjectConverters;
import org.junit.Assert;
import org.junit.Test;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
public class TemporalConvertersTest {

    @Test
    public void testToString() {
        final ZonedDateTime input = ZonedDateTime.now();

        TemporalConverters.ZonedDateTime2String date2String = new TemporalConverters.ZonedDateTime2String();
        final String output = date2String.apply(input);
        Assert.assertTrue("Formatted date is not a valid timestamp !", input.isEqual(TemporalConverters.fromTimestamp(Long.parseLong(output))));
    }

    @Test
    public void testFromString() {
        // Separator shuffle !
        final String firstTest = "2015-04-19_10/12.14;GMT+02:00";
        final ZonedDateTime firstExpected = ZonedDateTime.of(2015, 04, 19, 10, 12, 14, 0, ZoneId.of("UTC+02:00"));
        // Simple say first date.
        final String secondTest = "19-04-2016";
        final ZonedDateTime secondExpected = ZonedDateTime.of(LocalDate.of(2016, Month.APRIL, 19), LocalTime.MIDNIGHT, ZoneOffset.UTC);
        // ISO date time
        final ZonedDateTime thirdExpected = ZonedDateTime.now();
        final String thirdTest = thirdExpected.format(DateTimeFormatter.ISO_ZONED_DATE_TIME);
        // A timestamp put in a string
        final String fourthTest = Long.toString(thirdExpected.toInstant().toEpochMilli());

        TemporalConverters.String2ZonedDateTime str2Date = new TemporalConverters.String2ZonedDateTime();
        Assert.assertTrue("Random separator conversion failed !", firstExpected.isEqual(str2Date.apply(firstTest)));
        Assert.assertTrue("Simple day first date conversion failed !", secondExpected.isEqual(str2Date.apply(secondTest)));
        Assert.assertTrue("ISO date conversion failed !", thirdExpected.isEqual(str2Date.apply(thirdTest)));
        Assert.assertTrue("String timestamp conversion failed !", thirdExpected.isEqual(str2Date.apply(fourthTest)));
    }

    @Test
    public void testToLong() {
        final ZonedDateTime input = ZonedDateTime.now();

        TemporalConverters.ZonedDateTime2Long date2Long = new TemporalConverters.ZonedDateTime2Long();
        final Long output = date2Long.apply(input);
        Assert.assertTrue("Formatted date is not a valid timestamp !", input.isEqual(new Timestamp(output).toInstant().atZone(ZoneOffset.UTC)));
    }

    @Test
    public void testFromLong() {
        final long milli = System.currentTimeMillis();
        final ZonedDateTime expected = ZonedDateTime.from(Instant.ofEpochMilli(milli).atZone(ZoneOffset.UTC));

        TemporalConverters.Long2ZonedDateTime long2Date = new TemporalConverters.Long2ZonedDateTime();
        Assert.assertTrue("Long to date and time conversion failed !", expected.isEqual(long2Date.apply(milli)));
    }

    @Test
    public void testDiscovery() {
        try {
            Assert.assertEquals(TemporalConverters.String2ZonedDateTime.class, ObjectConverters.find(String.class, ZonedDateTime.class).getClass());
            Assert.assertEquals(TemporalConverters.ZonedDateTime2String.class, ObjectConverters.find(ZonedDateTime.class, String.class).getClass());

            Assert.assertEquals(TemporalConverters.Long2ZonedDateTime.class, ObjectConverters.find(Long.class, ZonedDateTime.class).getClass());
            Assert.assertEquals(TemporalConverters.ZonedDateTime2Long.class, ObjectConverters.find(ZonedDateTime.class, Long.class).getClass());
        } catch (Exception e) {
            RhomeoCore.LOGGER.log(Level.INFO, SystemRegistry.INSTANCE.toString());
            throw e;
        }
    }
}
